#!/bin/bash

 rm -rf remd_all.stat
 tail -q -n +200 2WFU_dock*.stat >remd_all.stat
 if [ ! -s remd_all.stat ]; then
  echo 'FATAL error - stat files empty'
  exit 2
 fi

 grep ACC 2WFU_dock.out_GB000 |tail -7
 exchange=`grep ACC 2WFU_dock.out_GB000 |tail -7|awk '{a=a+$4}END{print a/NR}'`
 echo "average exchange = ${exchange}"
 if [ `echo "a=${exchange};a<0.2"|bc -l` != "0" ]; then
    echo 'ERROR average exchange smaller than 0.2'
    exit 1
 else
    exit 0
 fi

